C	VAXUSE - THIS PROGRAM TRANSLATES VAX USE STATISTICS GENERATED BY
C		 PROGRAM ACC1 INTO RESOURCE UNIT VALUES.  THE REPORT FILE
C		 GENERATED BY ACC1 SHOULD BE USED AS THE INPUT FILE.
C		 DISK BLOCKS USED FOR EACH USER ARE INPUT FROM THE TERMINAL.
C
C	J. THOMPSON  INTERMETRICS  NOVEMBER 23, 1978
C	ADDED DISK SPACE ACCOUNTING JANUARY 7, 1979
C
	IMPLICIT REAL*8 (A-H,N-Z)
	CHARACTER*30	INFILE,OUTFILE
	CHARACTER	USERNAME*12,DASH*3
C
	DASH=' - '
C
C	DEFINE DEFAULT RESOURCE UNIT FACTORS (MULTIPLIERS)
C
	FCT=1.0D0	!CONNECT TIME
	FCP=11.0D0	!CPU TIME (APPLIED TO CPU HOURS)
	FPP=1.0D0/100.0D0	!PAGES PRINTED
	FIOB=1.0D0/8000.0D0	!BUFFERED IO BLOCKS
	FIOD=1.0D0/12000.0D0	!DIRECT IO BLOCKS
	FDB=1.0D0/250.0D0	!DISK BLOCK STORAGE FACTOR
	FSU=1.0D0/10.0D0	!SYSTEM UNIT FACTOR
	SPACEMAX=10000.0D0	!MAX DISK BLOCK STORAGE PER USER. AFTER THIS
				!MUCH STORAGE IS USED PENALTY IS > ONE.
C
C	CHECK FOR NEW RESOURCE UNIT FACTOR DEFINITIONS
C
	TYPE *, 'TYPE 1 TO INPUT NEW RESOURCE UNIT FACTORS'
	ACCEPT *, IR
	IF(IR.NE.1) GO TO 100
	TYPE *, 'NOTE:  ANY NEGATIVE INPUT GIVES DEFAULT VALUE HEREAFTER.'
	TYPE *, 'TYPE CONNECT TIME FACTOR (DEFAULT = 1.0)'
	ACCEPT *, FCT
	IF(FCT.LT.0.0D0) FCT=1.0D0
	TYPE *, 'TYPE CPU TIME FACTOR (DEFAULT = 11.0)'
	ACCEPT *, FCP
	IF(FCP.LT.0.0D0) FCP=11.0D0
	TYPE *, 'TYPE PAGES PRINTED FACTOR (DEFAULT = 0.01)'
	ACCEPT *, FPP
	IF(FPP.LT.0.0D0) FPP=0.01D0
	TYPE *, 'TYPE BUFFERED IO BLOCKS FACTOR (DEFAULT = 0.000125)'
	ACCEPT *, FIOB
	IF(FIOB.LT.0.0D0) FIOB=0.000125D0
	TYPE *,'TYPE DIRECT IO BLOCKS FACTOR (DEFAULT = 0.00008333)'
	ACCEPT *, FIOD
	IF(FIOD.LT.0.0D0) FIOD=0.00008333D0
	TYPE *,'TYPE DISK BLOCK STORAGE FACTOR (DEFAULT = 0.004)'
	ACCEPT *,FDB
	IF(FDB.LT.0.0D0) FDB=0.004D0
	TYPE *,'TYPE DISK BLOCK STORAGE SPACEMAX (DEFAULT = 10000 BLOCKS)'
	ACCEPT *,SPACEMAX
	IF(SPACEMAX.LT.0.0D0) SPACEMAX=10000.0D0
	TYPE *, 'TYPE SYSTEM UNIT FACTOR (DEFAULT = 0.1)'
	ACCEPT *,FSU
	IF(FSU.LT.0.0D0) FSU=0.1D0
C
C	OPEN IO FILES
C
100	TYPE *, 'TYPE INPUT FILE NAME'
	ACCEPT 10, INFILE
10	FORMAT(A)
	IF(INFILE.EQ.' ') GO TO 100
	OPEN(UNIT=1,NAME=INFILE,TYPE='OLD',READONLY)
200	TYPE *, 'TYPE OUTPUT FILE NAME'
	ACCEPT 10, OUTFILE
	IF(OUTFILE.EQ.' ') GO TO 200
	OPEN(UNIT=2,NAME=OUTFILE)
C
C	READ UNTIL FIND "USERNAME"
C
300	READ(1,20,END=600) USERNAME
20	FORMAT(' ',A)
	IF(USERNAME.NE.'USERNAME    ') GO TO 300
C
C	WRITE TITLE, ETC. FOR OUTPUT FILE
C
	WRITE(2,30)
30	FORMAT('1',T25,'***  VAX RESOURCE UNIT USE SUMMARY  ***',//
     1	   ' USERNAME',T15,'CONNECT RU',T30,'CPU RU',
     2	   T38,'BUF IO RU',T49,'DIR IO RU',T61,'PRINT RU',
     3	   T73,'DISK RU',T83,'TOTAL SU',T91,'   ACCOUNT'/)
C
C	ZERO SUMS
C
	SUMCT=0.0D0
	SUMCP=0.0D0
	SUMPP=0.0D0
	SUMIOB=0.0D0
	SUMIOD=0.0D0
	SUMBLKS=0.0D0
	SUMRU=0.0D0
	SUMSU=0.0D0
C
C	MAIN LOOP
C
40	FORMAT(' ',A12,I10,I7,':',I2,':',I2,F12.0,5I10)
400	READ(1,40) USERNAME,JUNK,IHRS,IMINS,ISECS,CPU_SEC,IOB,IOD,
     1	   LUNK,MUNK,IPAGES
	IF(USERNAME(1:1).EQ.' ') GO TO 500
C	GET DISK BLOCK USEAGE FOR THIS USER
410	WRITE(6,45) USERNAME
45	FORMAT(' TYPE AVERAGE DISKBLOCKS USED FOR USER ',A12)
	READ(5,46,ERR=410,END=410) BLOCKS
46	FORMAT(F12.0)
C	USE QUADRATIC PENALTY WHEN DISK BLOCKS EXCEED SPACEMAX
	PENALTY=(BLOCKS/SPACEMAX)**2
	IF(PENALTY.LT.1.0D0) PENALTY=1.0D0
C
	CTHRS=IHRS+((IMINS/60.0D0)+(ISECS/3600.0D0))
	CPHRS=CPU_SEC/3600.0D0
	BIO=IOB
	DIO=IOD
	PGS=IPAGES
C
	CTRU=CTHRS*FCT
	CPRU=CPHRS*FCP
	BIORU=BIO*FIOB
	DIORU=DIO*FIOD
	PGSRU=PGS*FPP
	BLKRU=FDB*BLOCKS*PENALTY
	RU=CTRU+CPRU+BIORU+DIORU+PGSRU+BLKRU
	SU=RU*FSU
C
	SUMCT=SUMCT+CTRU
	SUMCP=SUMCP+CPRU
	SUMIOB=SUMIOB+BIORU
	SUMIOD=SUMIOD+DIORU
	SUMPP=SUMPP+PGSRU
	SUMBLKS=SUMBLKS+BLKRU
	SUMRU=SUMRU+RU
	SUMSU=SUMSU+SU
C
	WRITE(2,50) USERNAME,CTRU,CPRU,BIORU,DIORU,PGSRU,BLKRU,SU,DASH
50	FORMAT(' ',A12,7(1X,F10.3),A3)
C
	GO TO 400	!CONTINUE LOOP
C
C	WRITE SUMMARY
C
500	WRITE(2,60)
60	FORMAT(' ')
	USERNAME='**TOTALS**  '
	WRITE(2,50) USERNAME,SUMCT,SUMCP,SUMIOB,SUMIOD,SUMPP,SUMBLKS,SUMSU
	STOP '***  DONE  ***'
C	INPUT FILE ERROR
600	TYPE *, 'INPUT FILE READ ERROR'
	STOP '***  ERROR   ***'
	END
