C
C PROGRAM NAME:		FILEDIF
C
C PURPOSE:		PROGRAM WILL COMPARE TWO FORMATTED COPIES (AS
C			PREPARED BY FILE DUMP SYSTEM) OF THE SAME FILE.
C			THE FILES ARE STORED IN 'PRMFLE.DAT' AND
C			'SCNFLE.DAT'.  THE FILES ARE COMPARED ON A
C			RECORD BY RECORD AND CHARACTER BY CHARACTER
C			BASIS.  ANY DIFFERENCES THAT ARE DETECTED ARE
C			LOADED INTO THE OUTPUT FILE 'FILE.DIR'.
C
C AUTHOR:		THOMAS L. TERRALL
C
C NOTES:		1. COMPILE
C				$FOR/LIS/CHECK=ALL FILEDIF.FOR
C			2. LINK
C				$LINK FILEDIF.OBJ,EXTRCTINT.OBJ
C
	LOGICAL*1	STATUS
C
	INTEGER*2	RCR,RSI,RSJ,I,J,ERR,NMBR_ERR,ENDI,ENDJ,
	1		EXPTD_RCR,ACTUAL_RCR
C
	CHARACTER*1	ERR_THIS_RCR
C
	CHARACTER*8	FILE_NAME
C
	CHARACTER*80	LINE_CHAR
C
	CHARACTER*140	IN,JN,OUT
C
C	OPEN FILES
C
	OPEN(UNIT=10,NAME='FILE.DIF',TYPE='NEW')
	OPEN(UNIT=20,NAME='PRMFLE.DAT',TYPE='OLD')
	OPEN(UNIT=30,NAME='SCNFLE.DAT',TYPE='OLD')
C
C	GET FILE NAME FROM PRMFILE.DAT
C
	OPEN(UNIT=40,NAME='PRMFILE.DAT',TYPE='OLD')
	READ(40,10)FILE_NAME
10	FORMAT(A8)
	CLOSE(UNIT=40,DISPOSE='DELETE')
C
C	INITIALIZE FOR COMPARISON
C
	RCR=0
	NMBR_ERR=0
	EXPTD_RCR=1
	ACTUAL_RCR=0
	ENDI=0
	ENDJ=0
	WRITE(10,20)FILE_NAME
20	FORMAT('1'/10X'FILE DIFFERENCES FOR - 'A8' - (FILEDIR)'/)
	WRITE(6,*) '      # # # BEGIN FILEDIF # # #'
C
C	READ NEXT RECORD FROM EACH FILE
C
100	READ(20,150,END=155)RSI,(IN(I:I),I=1,RSI)
150	FORMAT(Q,140A)
	GO TO 160
155	ENDI=1
C
160	READ(30,150,END=165)RSJ,(JN(J:J),J=1,RSJ)
	IF(ENDI .EQ. 1) GO TO 400
	GO TO 168
165	ENDJ=1
	GO TO 400
C
C	TEST BOTH FILES HAVE SAME RECORD SIZE
C
168	IF(RSI .EQ. RSJ)GO TO 200
	WRITE(10,170)RCR
170	FORMAT('0',5X'RECORD - 'I5' HAVE RECORD SIZE MISMATCH')
	GO TO 100
C
C	COMPARE RECORDS CHARACTER BY CHARACTER
C
200	OUT(1:140)=' '
	RCR=RCR+1
C
	ERR=0
C
C	ATTEMPT TO LOCATE RECORD NUMBER IN LINE FORM PRIMARY FILE
C
	LINE_CHAR(1:7)=IN(1:7)
	IF(LINE_CHAR(7:7) .NE.  ' ') GO TO 210
C
	CALL EXTRCTINT(LINE_CHAR,2,6,INTEGER,STATUS)
	IF(STATUS .NE. 0)GO TO 210
	IF(INTEGER .NE. EXPTD_RCR) GO TO 210
	ACTUAL_RCR=INTEGER
	ERR_THIS_RCR='F'
	RCR=1
	EXPTD_RCR=EXPTD_RCR+1
C
210	DO 220 I=1,RSI
	IF(IN(I:I) .EQ. JN(I:I) )GO TO 220
	ERR=ERR+1
	OUT(I:I)='-'
220	CONTINUE
C
C	PRINT OUT RECORD IF ANY MISMATCHES HAVE BEEN FOUND
C
	IF(ERR .EQ. 0) GO TO 100
	IF(ERR_THIS_RCR .EQ. 'T')GO TO 302
	ERR_THIS_RCR = 'T'
	NMBR_ERR=NMBR_ERR+1
302	WRITE(10,303)RCR,ACTUAL_RCR,ERR
303	FORMAT('0'5X'PRINT LINE - 'I2' OF DATA RECORD - '
	1	I5' HAS 'I3' MISMATCHES')
	WRITE(10,305)(IN(I:I),I=1,RSI)
305	FORMAT(140A)
	WRITE(10,305)(OUT(I:I),I=1,RSI)
	WRITE(10,305)(JN(I:I),I=1,RSI)
	GO TO 100
C
C	END PROGRAM
C
C		TEST BOTH FILES HAVE BEEN COMPLETELY READ
C
400	IF(ENDI+ENDJ .EQ. 2) GO TO 402
	WRITE(6,*) ' THE TWO FILES DO NOT HAVE THE SAME NUMBER OF RECORDS'
C
C		OUTPUT CLOSING ERROR SUMMARY
C
402	WRITE(10,410)NMBR_ERR
410	FORMAT(/10X'A TOTAL OF - 'I5,
	1	' DATA RECORDS HAVE ERRORS')
C
C		CLOSE FILES
C
	CLOSE(UNIT=10)
	CLOSE(UNIT=20,DISPOSE='DELETE')
	CLOSE(UNIT=30,DISPOSE='DELETE')
C
	WRITE(6,*) '    # # # END FILEDIF # # #'
	CALL EXIT
	END
C
C PROGRAM NAME:		EXTRCTINT
C
	SUBROUTINE EXTRCTINT(LINE_CHAR,LEFT_LIM,RIGHT_LIM,INTEGER,STATUS)
C
C
C PURPOSE:	EXTRCTINT WILL EXTRACT AN INTEGER VALUE THAT IS IN CHARACTER
C		FORM IN A SPECIFIED INTERVAL OF A LINE OF CHARACTERS AND
C		DECODE IT INTO AN INTEGER*2 VARIABLE. BLANKS ARE IGNORED.
C AUTHOR:	THOMAS L. TERRALL
C
C
C	INPUT PARAMETERS:
C
C	LINE_CHAR	LINE OF CHARACTERS CONTAINING INTEGER		C*80
C	LEFT_LIM	START OF INTEGER FIELD IN LINE_CHAR		I*2
C	RIGHT_LIM	END OF INTEGER FIELD IN LINE_CHAR		I*2
C
C	OUTPUT PARAMETERS:
C
C	INTEGER		RETURNED INTEGER VALUE				I*2
C	STATUS		STATUS OF CONVERSION				L*1
C
C
C	STATUS CODES:
C
C	 0	SUCCESSFUL CONVERSION
C	-1	NON-DIGIT CHARACTER FOUND IN INTEGER FIELD
C	-2	MORE THAN 6 CHARACTERS IN INTEGER FIELD
C	-3	DECODE FAILURE
C	-4	INTERVAL SPECIFICATION IS IMPROPER
C	-5	NO DIGITS FOUND IN INTEGER FIELD
C
C NOTES:	COMPILE

C		$FOR/LIS/CHECK=ALL/DEBUG/NOOPTIMIZE/NOI4 EXTRCTINT.FOR
C
C	DECLARATIONS
C
	LOGICAL*1	STATUS,SIGN_FOUND,DIGIT_FOUND
C
	INTEGER*2	LEFT_LIM,RIGHT_LIM,INTEGER,LN_PTR,IN_PTR,I
C
	CHARACTER*6	INT	!HOLDS DIGITS AND SIGN EXTRACTED FROM LINE_CHAR
C
	CHARACTER*80	LINE_CHAR
C
C
	IN_PTR = 7	!INITIALIZE POSITION IN INT
	INT = ' '	!BLANK INT ARRAY
	SIGN_FOUND = .FALSE.	!SET SIGN NOT FOUND
	DIGIT_FOUND = .FALSE.
C
C	ARE INTERVAL PARAMETERS VALID AND CONSISTENT?
	IF(RIGHT_LIM .LT. LEFT_LIME) GO TO 120
	IF(RIGHT_LIM .GT. 80) GO TO 120
	IF(LEFT_LIM .LE. 0 ) GO TO 120
	GO TO 200
120	STATUS = -4	!SET IMPROPER INTERVAL STATUS CODE
	GO TO 900
C
C
C	SEARCH THROUGH LINE_CHAR FROM RIGHT_LIM TO LEFT_LIM MOVING
C	DIGITS TO INT, IGNORING BLANKS
C
200	DO 280	LN_PTR = RIGHT_LIM,LEFT_LIM,-1
	IF(LINE_CHAR(LN_PTR:LN_PTR) .EQ. ' ') GO  TO 280
	IF(SIGN_FOUND .EQ. .TRUE.)GO TO 225
	IF(LINE_CHAR(LN_PTR:LN_PTR) .NE. '+') GO TO 210
	GO TO 215
210	IF(LINE_CHAR(LN_PTR:LN_PTR) .NE. '-') GO TO 220
215	SIGN_FOUND = .TRUE.	!SET SIGN FOUND
	GO TO 264
220	IF(LINE_CHAR(LN_PTR:LN_PTR) .GE. '0' .AND.
	1    LINE_CHAR(LN_PTR:LN_PTR) .LE. '9') GO TO 260	!DIGIT?
225	STATUS = -1	!SET NON-DIGIT CHARACTER STATUS CODE
	GO TO 900
C
C	MOVE CHARACTER
260	DIGIT_FOUND = .TRUE.	!SET DIGIT FOUND
264	IN_PTR = IN_PTR	- 1
	IF(IN_PTR .GT. 0) GO TO 268	!ANY SPACE IN INT?
	STATUS = -2	!SET MORE THAN 6 DIGITS FOUND STATUS CODE
	GO TO 900
C
268	INT(IN_PTR:IN_PTR) = LINE_CHAR(LN_PTR:LN_PTR)
280	CONTINUE
	IF(DIGIT_FOUND .EQ. .TRUE.) GO TO 285
	STATUS = -5	!SET NO DIGITS FOUND CODE
	GO TO 900
C
C	CONVERT CHARACTERS IN INT INTO INTERGER VALUE IN INTEGER
285	DECODE(6,30,INT,ERR=290)INTEGER
30	FORMAT(I6)
	GO TO 800
290	STATUS = -3	!SET DECODE FAILURE STATUS CODE
	GO TO 900
C
800	STATUS = 0
900	RETURN
	END
