	PROGRAM FXREF
C
C	FXREF PARSES AN INPUT FILE LINE BY LINE.  WHEN IT FINDS A NUMBER
C	QUOTED STRING, IDENTIFIER, OR HOLLERITH DATA IT PRODUCES A RECORD WITH
C	A TYPE FLAG, A 16 CHARACTER STRING FOR THE ITEM, AND A LINE NUMBER
C	KEYED TO A NUMBERED OUTPUT FILE THAT IT ALSO OUTPUTS.  MOST RESERVED
C	WORDS FOR VAX FORTRAN IV PLUS ARE NOT PRODUCED.  BLANKS IN NUMBERS
C	OR IDENTIFIERS ARE NOT SIGNIFICANT.  NEITHER ARE TABS.
C	IN QUOTED STRINGS BLANKS AND TABS ARE SIGNIFICANT.
C
C	J. THOMPSON  INTERMETRICS  FEBRUARY 14, 1979
C	CROCK PROCESSING ($ IN COL 1 AND SIGNIFICANT BLANKS AND TABS)
C	ADDED MARCH 2, 1979.  COMMANDC, EOLCHAR, CMODE, NOCMODE IMPLEMENTED.
C
C	PROGRAM GENERATION:	FOR FXREF
C				FOR BNUMB
C				FOR BQSTR
C				FOR BIDENT
C				FOR TNUMB
C				FOR PRODUCE
C				LINK FXREF,BNUMB,TNUMB,BQSTR,BIDENT,TNUMB,-
C					PRODUCE
C
	PARAMETER	MAXCHAR=80 !MAX CHARACTERS TO PROCESS IN A RECORD
C
	INTEGER*4	FORMAT_LINE	!=1 INDICATES FORMAT LINE JUST DONE
	INTEGER*4	P	!INPUT LINE CHARACTER POINTER
	LOGICAL*1	L(256),LS(16),EOL
	CHARACTER*1	EOLCHAR,COMMANDC
	CHARACTER*78	FILENAME,RESFILE
	CHARACTER*256	LINE
	CHARACTER*16	STRING,RESERVED(200),PROC_NAME
C
	COMMON/FXREFA/ LINE,RESERVED
	COMMON/FXREFB/ FORMAT_LINE,NCHAR,MAX,LINE_NO,MAX_RES,IFIRST,IDO
	COMMON/FXREFD/ ISB,MAXI
	COMMON/FXREFE/ STRING
	COMMON/FXREFF/ EOLCHAR,COMMANDC
	COMMON/FXREFG/ NOCMODE,ICRK
	COMMON/FXREFS/ K1A(128),K2A(128)
	EQUIVALENCE (L(1),LINE(1:1))
	EQUIVALENCE (LS(1),STRING(1:1))
	EQUIVALENCE (EOL,EOLCHAR(1:1))
C
	WRITE(6,*) 'INTERMETRICS FORTRAN IV CROSS REFERENCE PROGRAM - 
	1REV 1.0 VAX'
	WRITE(6,*) 'TYPE FORTRAN DECK FILE NAME'
	READ(5,10) FILENAME
10	FORMAT(A)
	OPEN(UNIT=1,NAME=FILENAME,READONLY,TYPE='OLD',BLOCKSIZE=5632)
	OPEN(UNIT=2,NAME='FXREFOUT.DAT',TYPE='NEW',BLOCKSIZE=5632)
	OPEN(UNIT=3,NAME='CROSSREF.LIS',TYPE='NEW',CARRIAGECONTROL='LIST',
	1 BLOCKSIZE=5632)
C	PUT OUT HEADING FOR LISTING
	WRITE(3,15)
15	FORMAT(////,T20,' LISTING FILE FOR FXREF PROGRAM ',//)
C	OBTAIN THE LIST OF RESERVED WORDS
	WRITE(6,*) 'TYPE RESERVED WORD LIST FILE NAME'
	READ(5,10) RESFILE
	OPEN(UNIT=4,NAME=RESFILE,READONLY,TYPE='OLD',BLOCKSIZE=5632)
	MAX_RES=0
	DO 100 I=1,200
	READ(4,20,END=105) RESERVED(I)
100	MAX_RES=I
105	CLOSE(UNIT=4)
C	SET THE PROCESS NAME
	CALL SETPRN('FXREF',PROC_NAME)
C	FIGURE OUT LIMITS FOR RESERVED WORD SEARCHES
C	RESERVED.DAT MUST BE SORTED ALPHABETICALLY
	DO 110 I=65,90 !ONLY ALLOW CAPS
	K1A(I)=0
110	K2A(I)=0
	IF(MAX_RES.EQ.0) GO TO 150
	DO 120 I=1,MAX_RES
	STRING=RESERVED(I)
	K=LS(1) !USE CHARACTER CODE AS INDEX
	IF(K.LT."101.AND.K.GT."142)
	1 STOP 'RESERVED.DAT MUST NOT HAVE LOWER CASE CHARACTERS OR
	2OR START WITH SPECIAL CHARACTERS'
	IF(K1A(K).EQ.0) K1A(K)=I !STARTING VALUE FOR SEARCH
120	K2A(K)=K2A(K)+1 !# OF RESERVED WORDS WITH THIS STARTING VALUE
	DO 130 K=65,90
	IF(K1A(K).NE.0) K2A(K)=K1A(K)+K2A(K)-1
130	CONTINUE
20	FORMAT(A16)
150	FORMAT_LINE=0	!LAST LINE WAS NOT A FORMAT LINE
	IDO=0		!LAST LINE NOT A DO LINE
	IFIRST=1	!LOOKING FOR FIRST SYMBOL
	LINE_NO=0	!LINE COUNTER
	ICRK=0 !CROCK IS NOT ASSUMED BY DEFAULT
	EOL=0 !NO DEFAULT EOLCHAR FOR CROCK
	COMMANDC='$' !DEFAULT CROCK COMMAND CHARACTER IN COL 1
	NOCMODE=1 !DEFAULT CROCK REQUIRES COMMANDC IN COL 1
	MAX=MAXCHAR
C	CALL START_TIME(1,240,2,'PC.DAT')
C	GET A LINE FROM THE INPUT FILE
200	READ(1,30,ERR=200,END=800) NCHAR,(LINE(J:J), J=1,NCHAR)
	LINE_NO=LINE_NO+1
30	FORMAT(Q,<NCHAR>A)
31	FORMAT(1X,I6,1X,A)
	WRITE(3,31) LINE_NO,LINE(1:NCHAR)
	IF(NCHAR.GT.MAX) NCHAR=MAX
C*****
	ISB=0	!ASSUME BLANKS AND TABS ARE NOT SIGNIFICANT
C*****
	IF(NOCMODE.EQ.1) GO TO 210 !ALL LINES MAY BE CROCK LINES
	ICRK=1 !CROCK CMODE IN EFFECT.  ALL LINES TREATED AS CROCK LINES
	ISB=1 !BLANKS AND TABS ARE SIGNIFICANT
	GO TO 235
210	IF(LINE(1:1).NE.COMMANDC) GO TO 235 !MAY BE CROCK LINE
230	ICRK=1 !CROCK IN EFFECT
	ISB=1	!BLANKS AND TABS ARE SIGNIFICANT
235	IF(L(1)-"103) 240,200,240 !TEST FOR 'C'
240	IF(L(1)-"143) 245,200,245 !TEST FOR 'c'
245	IF(LINE(1:1).EQ.'D'.OR.LINE(1:1).EQ.'d') LINE(1:1)=' '
C	TEST FIRST FEW CHARACTERS ON THE LINE
	P=0
C	TRY TO SWALLOW BLANKS
250	P=P+1
	IF(L(P)-"40) 255,250,255
255	IF(P-6) 260,270,275 !DIG OR TAB,TAB OR CONT,START LINE @ P
C	START LINE OR TAB WITHIN COLUMNS 1-5
260	IF(L(P)-"11) 275,265,275 !START @ P,TAB,START @ P
C	TAB FOUND - NOW TEST NEXT CHARACTER FOR NONZERO DIGIT
265	P=P+1
	IF(L(P).GE."61.AND.L(P).LE."71) GO TO 278 !CONT
	GO TO 275 !START LINE @ P
C	COLUMN 6 TESTS
270	IF(L(P)-"11) 272,265,272 !ZERO TEST,TAB,ZERO TEST
C	TEST FOR ZERO IN THIS COLUMN
272	IF(L(P)-"60) 278,273,278 !CONT,P+1,CONT
273	P=P+1
C	START LINE AT P
275	IFIRST=1 !INDICATE LOOKING FOR FIRST SYMBOL ON LINE
	FORMAT_LINE=0 !CANCEL LAST LINE WAS A FORMAT LINE
	IDO=0	!CANCEL LAST LINE WAS A DO LINE
	GO TO 310 !START LINE AT P
C	CONTINUATION LINE
278	P=P+1
	IF(FORMAT_LINE) 200,310,200 !YES,NO,YES
C	DO THE REST OF THE LINE
300	P=P+1	!POINT TO NEXT CHARACTER TO PROCESS
310	IF(P.GT.NCHAR) GO TO 200
	IF(LINE(P:P).EQ.' ') GO TO 300 !DON'T PROCESS BLANKS
C	TRY TO BUILD AN IDENTIFIER (SYMBOL)
	IF(L(P).LT."101.OR.L(P).GT."132) GO TO 600
500	CALL BIDENT(P,LAST)
	P=LAST
	IF(LINE(P:P).EQ.'!') GO TO 200
	IF(ICRK.EQ.1.AND.LINE(P:P).EQ.EOLCHAR) GO TO 200 !CROCK EOL
	IF(FORMAT_LINE.EQ.0) GO TO 300
	GO TO 200
C	TRY TO BUILD A NUMBER
600	IF(L(P).LT."60.OR.L(P).GT."71) GO TO 650
	CALL BNUMB(P,LAST)
	P=LAST
	IF(LINE(P:P).EQ.'!') GO TO 200
	IF(ICRK.EQ.1.AND.LINE(P:P).EQ.EOLCHAR) GO TO 200 !CROCK EOL
	GO TO 300
C	TRY TO BUILD QUOTED STRING
650	IF(L(P).NE."47) GO TO 700
	CALL BQSTR(P+1,LAST)
	P=LAST
	IF(LINE(P:P).EQ.'!') GO TO 200
	IF(ICRK.EQ.1.AND.LINE(P:P).EQ.EOLCHAR) GO TO 200 !CROCK EOL
	GO TO 300
700	IF(L(P).EQ."11) GO TO 300
	IF(L(P).GE."141.AND.L(P).LE."172) GO TO 500
	IF(LINE(P:P).EQ.'!') GO TO 200
	IF(ICRK.EQ.0) GO TO 300
	IF(LINE(P:P).EQ.EOLCHAR) GO TO 200 !CROCK EOLCHAR FOUND
	IF(LINE(P:P).EQ.'&') GO TO 500     !CROCK AMPERSAND
	GO TO 300
C	END OF INPUT FILE
C800	CALL STOP_TIME
800	STOP '*** END FXREF PARSE ***'
	END
